#!/usr/bin/ruby -w

require 'socket'
require 'thread'

class ChatClient

	def initialize(host, port)
		@socket = TCPSocket.new(host, port)
		@on_recieve = nil
	end

	def on_recieve(&on_recieve) # block elmentese peldanyvaltozoba
		@on_recieve = on_recieve
	end

	def listen
		@listen_thread = Thread.new do
			while line = @socket.gets
				@on_recieve.call(line) if @on_recieve
			end
		end
	end

	def send(line)
		@socket.puts(line)
	end

	def close
		send('QUIT')
		@listen_thread.join
	end
end

host = ARGV[0] || 'localhost'
port = ARGV[1] || 1111

client = ChatClient.new(host, port)

# block atadasa
client.on_recieve { |line| puts "Received: #{line}" }

client.listen

while line = $stdin.gets
	break if /^exit/ =~ line
	client.send(line)
end
